var Tt = Object.defineProperty;
var Vt = (e, t, n) => t in e ? Tt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: n }) : e[t] = n;
var $ = (e, t, n) => (Vt(e, typeof t != "symbol" ? t + "" : t, n), n);
import { defineComponent as de, ref as v, computed as k, h as St, getCurrentInstance as ve, reactive as Ye, watch as Se, onMounted as ze, onBeforeUnmount as Bt, nextTick as Lt } from "vue-demi";
import { reactive as Mt, ref as Rt, openBlock as V, createElementBlock as H, createElementVNode as b, resolveComponent as fe, normalizeClass as m, mergeProps as pe, toHandlers as We, createBlock as Ne, resolveDynamicComponent as Nt, createCommentVNode as oe, withDirectives as ge, vShow as $e, Fragment as qe, createTextVNode as Je, toDisplayString as ke, withModifiers as _t, normalizeStyle as Pe, renderList as Ge, renderSlot as J, createVNode as Ke, vModelText as Ot, createSlots as $t, withCtx as je, normalizeProps as we, guardReactiveProps as De, Transition as Ht } from "vue";
const Ut = [
  "_level",
  "_filterVisible",
  "_parent",
  "_loading",
  "_loaded",
  "_remote",
  "_keyField",
  "children",
  "setChildren"
];
class ae {
  //#endregion Properties
  constructor(t, n = null, l = "id", a = !1) {
    /** 节点层级 */
    $(this, "_level", 0);
    /** 多选是否选中 */
    $(this, "checked", !1);
    /** 单选是否选中 */
    $(this, "selected", !1);
    /** 是否半选状态 */
    $(this, "indeterminate", !1);
    /** 是否禁用 */
    $(this, "disabled", !1);
    /** 是否展开 */
    $(this, "expand", !1);
    /** 是否可见 */
    $(this, "visible", !0);
    /** 过滤后是否可见，如果为 false 则在其他可见情况下也是不可见的 */
    $(this, "_filterVisible", !0);
    /** 父节点 */
    $(this, "_parent", null);
    /** 子节点 */
    $(this, "children", []);
    /** 是否是子节点 */
    $(this, "isLeaf", !1);
    /** 节点是否正在加载 */
    $(this, "_loading", !1);
    /** 子节点是否已加载 */
    $(this, "_loaded", !1);
    $(this, "reacData", Mt({
      showElement: !0
    }));
    this._keyField = l, this._remote = a;
    for (let i in t)
      Ut.indexOf(i) === -1 && (this[i] = t[i]);
    this[l] == null && (this[l] = Math.random().toString(36).substring(2)), this._parent = n, this._parent && (this._level = this._parent._level + 1), this.visible = this._parent === null || this._parent.expand && this._parent.visible, Array.isArray(t.children) && this.setChildren(t.children), this.children.length && (this._loaded = !0), this._remote || (this.isLeaf = !this.children.length);
  }
  /**
   * 设置子节点
   * @param children 子节点数据数组
   */
  setChildren(t) {
    this.children = t.map((n) => new ae(
      Object.assign({}, n),
      this,
      this._keyField,
      this._remote
    ));
  }
}
var Ae = /* @__PURE__ */ ((e) => (e.none = "none", e.parents = "parents", e.children = "children", e))(Ae || {});
const xt = [
  "setData",
  "setChecked",
  "setCheckedKeys",
  "checkAll",
  "clearChecked",
  "setSelected",
  "clearSelected",
  "setExpand",
  "setExpandKeys",
  "setExpandAll",
  "getCheckedNodes",
  "getCheckedKeys",
  "getIndeterminateNodes",
  "getSelectedNode",
  "getSelectedKey",
  "getExpandNodes",
  "getExpandKeys",
  "getCurrentVisibleNodes",
  "getNode",
  "getTreeData",
  "getFlatData",
  "getNodesCount",
  "insertBefore",
  "insertAfter",
  "append",
  "prepend",
  "remove",
  "filter",
  "showCheckedNodes",
  "loadRootNodes",
  "scrollTo"
];
var Kt = /* @__PURE__ */ ((e) => (e["bottom-start"] = "bottom-start", e["bottom-end"] = "bottom-end", e.bottom = "bottom", e["top-start"] = "top-start", e["top-end"] = "top-end", e.top = "top", e))(Kt || {}), _e = /* @__PURE__ */ ((e) => (e.top = "top", e.center = "center", e.bottom = "bottom", e))(_e || {}), q = /* @__PURE__ */ ((e) => (e.before = "before", e.body = "body", e.after = "after", e))(q || {});
const Xe = [
  "expand",
  "check",
  "click",
  "select",
  "node-dblclick",
  "node-right-click",
  "node-dragstart",
  "node-dragenter",
  "node-dragover",
  "node-dragleave",
  "node-drop"
];
class Wt {
  //#endregion Properties
  constructor(t) {
    //#region Properties
    /** 树数据 */
    $(this, "data", []);
    $(this, "hideElementIds", Rt({}));
    /** 扁平化的树数据 */
    $(this, "flatData", []);
    /** 树数据 map */
    $(this, "mapData", /* @__PURE__ */ Object.create(null));
    /** 未加载但已选中的节点 key ，每次 flattenData 的时候进行检查，将加载的节点从此数组中剔除 */
    $(this, "unloadCheckedKeys", []);
    /** 未加载但选中的单选节点 key */
    $(this, "unloadSelectedKey", null);
    /** 当前单选选中节点 key */
    $(this, "currentSelectedKey", null);
    /** 事件 listeners */
    $(this, "listenersMap", {});
    this.options = t;
  }
  changeNode(t) {
    const { type: n, data: l } = t;
    switch (n) {
      case "showElement":
        this.hideElementIds.value[l.id] = !1, console.log(this, "this");
        break;
    }
  }
  setData(t, n = null, l = null) {
    this.data = t.map(
      (a) => new ae(a, null, this.options.keyField, !!this.options.load)
    );
    for (let a in this.mapData)
      delete this.mapData[a];
    this.currentSelectedKey = null, this.flatData = this.flattenData(this.data), this.setUnloadCheckedKeys(l || []), n && (this.currentSelectedKey = null, this.setUnloadSelectedKey(n)), this.emit("visible-data-change"), this.emit("set-data");
  }
  //#region Set api
  /**
   * 设置单个节点多选选中
   * @param key 设置的节点 key
   * @param value 是否选中
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发 `data-change` 事件以通知外部刷新视图
   * @param filtering 是否正在过滤，如果是，则考虑 `filteredNodeCheckable` Prop，用于判断是否是用户点击节点触发的勾选
   */
  setChecked(t, n, l = !0, a = !0, i = !1) {
    const r = this.mapData[t];
    if (!r)
      return this.setUnloadChecked(t, n, l, a);
    r.disabled || r.checked && n || !r.checked && !r.indeterminate && !n || (this.options.cascade ? (this.checkNodeDownward(r, n, i), this.checkNodeUpward(r)) : r.checked = n, l && (r.checked ? this.emit("check", r) : this.emit("uncheck", r)), this.triggerCheckedChange(l, a));
  }
  /**
   * 设置单个未加载节点选中，不公开此 API
   */
  setUnloadChecked(t, n, l = !0, a = !0) {
    const i = this.findIndex(t, this.unloadCheckedKeys);
    n ? i === -1 && this.unloadCheckedKeys.push(t) : i !== -1 && this.unloadCheckedKeys.splice(i, 1), this.triggerCheckedChange(l, a);
  }
  /**
   * 批量选中/取消多选选中节点
   * @param keys 选中的节点 key 数组
   * @param value 是否选中
   * @param triggerEvent 是否触发事件
   */
  setCheckedKeys(t, n, l = !0, a = !0) {
    t.forEach((i) => {
      this.setChecked(i, n, !1, !1);
    }), this.triggerCheckedChange(l, a);
  }
  /**
   * 多选勾选全部节点
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  checkAll(t = !0, n = !0) {
    if (this.options.cascade) {
      const l = (a) => {
        a.forEach((i) => {
          i.disabled ? l(i.children) : this.setChecked(i[this.options.keyField], !0, !1, !1);
        });
      };
      l(this.data);
    } else {
      const l = this.flatData.length;
      for (let a = 0; a < l; a++) {
        const i = this.flatData[a];
        this.setChecked(i[this.options.keyField], !0, !1, !1);
      }
    }
    this.triggerCheckedChange(t, n);
  }
  /**
   * 清除所有多选已选
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  clearChecked(t = !0, n = !0) {
    this.getCheckedNodes().forEach((a) => {
      this.setChecked(a[this.options.keyField], !1, !1, !1);
    }), this.unloadCheckedKeys = [], this.triggerCheckedChange(t, n);
  }
  /**
   * 触发 checked-change 的快捷方法
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  triggerCheckedChange(t = !0, n = !0) {
    t && this.emit("checked-change", this.getCheckedNodes(), this.getCheckedKeys()), n && this.emit("render-data-change");
  }
  /**
   * 设置单选选中
   * @param key 选中节点 key
   * @param value 是否选中
   * @param triggerEvent 是否触发事件
   */
  setSelected(t, n, l = !0, a = !0) {
    const i = this.mapData[t];
    if (!i)
      return this.setUnloadSelected(t, n, l, a);
    i.disabled || i.selected !== n && (t === this.currentSelectedKey ? n || (i.selected = n, this.currentSelectedKey = null) : n && (this.currentSelectedKey === null ? (i.selected = n, this.currentSelectedKey = i[this.options.keyField]) : (this.mapData[this.currentSelectedKey] && (this.mapData[this.currentSelectedKey].selected = !1), i.selected = n, this.currentSelectedKey = i[this.options.keyField])), l && (i.selected ? this.emit("select", i) : this.emit("unselect", i), this.emit(
      "selected-change",
      this.getSelectedNode(),
      this.getSelectedKey()
    )), a && this.emit("render-data-change"));
  }
  /**
   * 设置未加载单选选中节点，不公开此 API
   */
  setUnloadSelected(t, n, l = !0, a = !0) {
    n ? (this.currentSelectedKey && this.setSelected(this.currentSelectedKey, !1, !1, !1), this.unloadSelectedKey = t) : this.unloadSelectedKey === t && (this.unloadSelectedKey = null), l && this.emit(
      "selected-change",
      this.getSelectedNode(),
      this.getSelectedKey()
    ), a && this.emit("render-data-change");
  }
  /**
   * 清除当前单选选中
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发视图刷新
   */
  clearSelected(t = !0, n = !0) {
    this.currentSelectedKey && this.mapData[this.currentSelectedKey] ? this.setSelected(
      this.currentSelectedKey,
      !1,
      t,
      n
    ) : this.unloadSelectedKey !== null && (this.unloadSelectedKey = null, t && this.emit(
      "selected-change",
      this.getSelectedNode(),
      this.getSelectedKey()
    ), n && this.emit("render-data-change"));
  }
  /**
   * 设置节点展开
   * @param key 节点 key
   * @param value 是否展开
   * @param expandParent 展开节点时是否同时展开父节点
   * @param triggerEvent 是否触发事件
   * @param triggerDataChange 是否触发 `data-change` 事件以通知外部刷新视图
   */
  setExpand(t, n, l = !1, a = !0, i = !0) {
    const r = this.mapData[t];
    if (!(!r || !l && r.isLeaf) && r.expand !== n) {
      if (console.log(r.isLeaf, "node.isLeaf"), !r.isLeaf) {
        if (typeof this.options.load == "function") {
          if (!r._loaded && !r._loading && n) {
            r._loading = !0, i && this.emit("visible-data-change"), new Promise((h, p) => {
              const _ = this.options.load;
              _(r, h, p);
            }).then((h) => {
              if (Array.isArray(h)) {
                const p = this.findIndex(r);
                if (p === -1)
                  return;
                r._loaded = !0, r.expand = n, r.setChildren(h);
                const _ = this.getCheckedKeys(), S = this.flattenData(
                  r.children,
                  this.getSelectedKey === null
                );
                this.flatData.splice(p + 1, 0, ...S), this.setUnloadCheckedKeys(_), this.unloadSelectedKey !== null && this.setUnloadSelectedKey(this.unloadSelectedKey), this.emit("set-data");
              }
            }).catch((h) => {
            }).then(() => {
              r._loading = !1, a && this.emit("expand", r), i && this.emit("visible-data-change");
            });
            return;
          } else if (r._loading)
            return;
        }
        r.expand = n;
        const d = [...r.children];
        for (; d.length; )
          d[0].expand && d[0].children.length && d.push(...d[0].children), d[0]._filterVisible === !1 ? d[0].visible = !1 : d[0].visible = d[0]._parent === null || d[0]._parent.expand && d[0]._parent.visible, d.shift();
        a && this.emit("expand", r), i && this.emit("visible-data-change");
      }
      l && r._parent && n && this.setExpand(
        r._parent[this.options.keyField],
        n,
        l,
        !1,
        i
      );
    }
  }
  /**
   * 批量设置节点展开/折叠
   * @param keys 展开的节点 key 数组
   * @param value 是否展开
   */
  setExpandKeys(t, n, l = !0) {
    t.forEach((a) => {
      this.setExpand(a, n, !1, !1, !1);
    }), l && this.emit("visible-data-change");
  }
  setExpandAll(t, n = !0) {
    this.flatData.forEach((l) => {
      (!this.options.load || l._loaded) && this.setExpand(l[this.options.keyField], t, !1, !1, !1);
    }), n && this.emit("visible-data-change");
  }
  //#endregion Set api
  //#region Get api
  /**
   * 获取多选选中节点
   * @param ignoreMode 忽略模式，可选择忽略父节点或子节点，默认值是 CTree 的 ignoreMode Prop
   */
  getCheckedNodes(t = this.options.ignoreMode) {
    if (t === Ae.children) {
      const n = [], l = (a) => {
        a.forEach((i) => {
          i.checked ? n.push(i) : !i.isLeaf && i.indeterminate && l(i.children);
        });
      };
      return l(this.data), n;
    } else
      return this.flatData.filter((n) => t === Ae.parents ? n.checked && n.isLeaf : n.checked);
  }
  /**
   * 获取多选选中的节点 key ，包括未加载的 key
   * @param ignoreMode 忽略模式，同 `getCheckedNodes`
   */
  getCheckedKeys(t = this.options.ignoreMode) {
    return this.getCheckedNodes(t).map((n) => n[this.options.keyField]).concat(this.unloadCheckedKeys);
  }
  /**
   * 获取多选半选状态节点
   */
  getIndeterminateNodes() {
    return this.flatData.filter((t) => t.indeterminate);
  }
  /**
   * 获取当前单选选中节点
   */
  getSelectedNode() {
    return this.currentSelectedKey === null ? null : this.mapData[this.currentSelectedKey] || null;
  }
  /**
   * 获取当前单选选中节点 key ，有可能是未加载的选中项
   */
  getSelectedKey() {
    return this.currentSelectedKey || this.unloadSelectedKey || null;
  }
  /**
   * 获取未加载但多选选中的节点
   */
  getUnloadCheckedKeys() {
    return this.unloadCheckedKeys;
  }
  /**
   * 获取展开节点
   */
  getExpandNodes() {
    return this.flatData.filter((t) => !t.isLeaf && t.expand);
  }
  /**
   * 获取展开节点 keys
   */
  getExpandKeys() {
    return this.getExpandNodes().map((t) => t[this.options.keyField]);
  }
  /**
   * 根据节点 key  获取节点
   * @param key 节点 key
   */
  getNode(t) {
    return this.mapData[t] || null;
  }
  //#endregion Get api
  //#region Node transfer api
  // 这边的 referenceKey 都是被执行的节点，比如 insertBefore ，在这里 referenceKey 就是指要插入到 referenceKey 节点前面
  insertBefore(t, n) {
    const l = this.getInsertedNode(t, n);
    if (!l)
      return null;
    this.remove(l[this.options.keyField], !1);
    const i = this.mapData[n]._parent, r = this.findIndex(
      n,
      i && i.children
    ), d = this.findIndex(n), h = i && -1 || this.findIndex(n, this.data);
    return this.insertIntoStore(l, i, r, d, h), this.emit("visible-data-change"), l;
  }
  insertAfter(t, n) {
    const l = this.getInsertedNode(t, n);
    if (!l)
      return null;
    this.remove(l[this.options.keyField], !1);
    const a = this.mapData[n], i = a._parent, r = this.findIndex(n, i && i.children) + 1, d = this.flatData.length, h = this.findIndex(n);
    let p = h + 1;
    for (let S = h + 1; S <= d; S++) {
      if (S === d) {
        p = S;
        break;
      }
      if (this.flatData[S]._level <= a._level) {
        p = S;
        break;
      }
    }
    const _ = i && -1 || this.findIndex(n, this.data) + 1;
    return this.insertIntoStore(l, i, r, p, _), this.emit("visible-data-change"), l;
  }
  append(t, n) {
    const l = this.mapData[n];
    if (!l.isLeaf) {
      const r = l.children.length;
      return this.insertAfter(
        t,
        l.children[r - 1][this.options.keyField]
      );
    }
    const a = this.getInsertedNode(t, n, !0);
    if (!a)
      return null;
    this.remove(a[this.options.keyField], !1);
    const i = this.findIndex(n) + 1;
    return this.insertIntoStore(a, l, 0, i), this.emit("visible-data-change"), a;
  }
  prepend(t, n) {
    const l = this.mapData[n];
    if (!l.isLeaf)
      return this.insertBefore(
        t,
        l.children[0][this.options.keyField]
      );
    const a = this.getInsertedNode(t, n, !0);
    if (!a)
      return null;
    this.remove(a[this.options.keyField], !1);
    const i = this.findIndex(n) + 1;
    return this.insertIntoStore(a, l, 0, i), this.emit("visible-data-change"), a;
  }
  /**
   * 删除节点
   * @param removedKey 要删除的节点 key
   */
  remove(t, n = !0) {
    const l = this.mapData[t];
    if (!l)
      return null;
    const a = this.findIndex(l);
    if (a === -1)
      return null;
    let i = 1;
    const r = this.flatData.length;
    for (let h = a + 1; h < r && this.flatData[h]._level > l._level; h++)
      i++;
    this.flatData.splice(a, i);
    const d = (h) => {
      const p = this.mapData[h];
      delete this.mapData[h], p.children.forEach((_) => d(_[this.options.keyField]));
    };
    if (d(t), !l._parent) {
      const h = this.findIndex(l, this.data);
      h > -1 && this.data.splice(h, 1);
    }
    if (l._parent) {
      const h = this.findIndex(l, l._parent.children);
      h !== -1 && l._parent.children.splice(h, 1), l._parent.isLeaf = !l._parent.children.length, l._parent.isLeaf && (l._parent.expand = !1, l._parent.indeterminate = !1), this.updateMovingNodeStatus(l);
    }
    return n && this.emit("visible-data-change"), l;
  }
  getInsertedNode(t, n, l = !1) {
    const a = this.mapData[n];
    if (!a)
      return null;
    const i = l ? a : a._parent;
    if (t instanceof ae)
      return t[this.options.keyField] === n ? null : t;
    if (typeof t == "object") {
      if (t[this.options.keyField] === n)
        return null;
      const r = this.mapData[t[this.options.keyField]];
      return r || new ae(
        t,
        i,
        this.options.keyField,
        !!this.options.load
      );
    } else
      return !this.mapData[t] || t === n ? null : this.mapData[t];
  }
  /**
   * 将一个节点插入 store 记录中
   * @param node 要插入的节点
   * @param parentNode 要插入节点的父节点
   * @param childIndex 如果有父节点，则需提供要插入的节点在同级节点中的顺序
   * @param flatIndex 在 flatData 中的索引
   * @param dataIndex 如果没有父节点，需要提供节点在 data 中的索引
   */
  insertIntoStore(t, n, l, a, i) {
    if (a === -1)
      return;
    l !== -1 && n && n.children.splice(l, 0, t), t._parent = n, n ? (n.isLeaf = !1, this.setExpand(
      n[this.options.keyField],
      !0,
      !1,
      !1,
      !1
    )) : typeof i == "number" && i > -1 && this.data.splice(i, 0, t);
    const r = this.flattenData([t]);
    t._level = n ? n._level + 1 : 0, r.forEach(
      (d) => d._level = d._parent ? d._parent._level + 1 : 0
    ), this.flatData.splice(a, 0, ...r), this.updateMovingNodeStatus(t);
  }
  updateMovingNodeStatus(t) {
    this.checkNodeUpward(t), this.triggerCheckedChange(), t.selected && this.setSelected(t[this.options.keyField], !0);
  }
  //#endregion Node transfer api
  /**
   * 过滤本地节点数据
   * @param keyword 过滤关键词
   * @param filterMethod 过滤方法
   */
  filter(t, n) {
    const l = [];
    this.flatData.forEach((a) => {
      a._filterVisible = a._parent && a._parent._filterVisible || n(t, a), a.visible = a._filterVisible, a._filterVisible && l.push(a);
    }), l.forEach((a) => {
      const i = [];
      let r = a._parent;
      for (; r; )
        i.unshift(r), r = r._parent;
      i.forEach((d) => {
        d._filterVisible = !0, d.visible = (d._parent === null || d._parent.expand && d._parent.visible) && d._filterVisible, this.options.expandOnFilter && this.setExpand(
          d[this.options.keyField],
          !0,
          !1,
          !1,
          !1
        );
      }), a.visible = a._parent === null || a._parent.expand && a._parent.visible;
    }), this.emit("visible-data-change");
  }
  /**
   * 过滤未加载多选节点，对比最终勾选节点是否有变化并触发 checked-change 事件
   * @param keys 全量选中节点 key 数组，包括加载与未加载选中节点
   */
  setUnloadCheckedKeys(t) {
    this.unloadCheckedKeys = t;
    const n = t.concat(), l = this.unloadCheckedKeys.length;
    for (let i = l - 1; i >= 0; i--) {
      const r = this.unloadCheckedKeys[i];
      this.mapData[r] && (this.setChecked(r, !0, !1, !1), this.unloadCheckedKeys.splice(i, 1));
    }
    const a = this.getCheckedKeys();
    a.length === n.length && a.every(
      (i) => n.some((r) => r === i)
    ) || this.emit("checked-change", this.getCheckedNodes(), a);
  }
  /**
   * 过滤未加载单选选中节点，对比是否有变化并触发 selected-change 事件
   * @param key 节点 key
   */
  setUnloadSelectedKey(t) {
    const n = this.getSelectedKey();
    this.mapData[t] ? (this.setSelected(t, !0, !1), this.unloadSelectedKey = null) : (this.currentSelectedKey && this.setSelected(this.currentSelectedKey, !1, !1), this.unloadSelectedKey = t);
    const l = this.getSelectedKey();
    l !== n && this.emit("selected-change", this.getSelectedNode(), l);
  }
  /**
   * 保存扁平化的节点数据 `flatData` 与节点数据 Map `mapData`
   * @param nodes 树状节点数据
   * @param overrideSelected 是否根据数据设置 `selected`
   */
  flattenData(t, n = !0, l = []) {
    const a = t.length;
    for (let i = 0; i < a; i++) {
      const r = t[i], d = r[this.options.keyField];
      if (l.push(r), this.mapData[d])
        throw new Error("[CTree] Duplicate tree node key.");
      this.mapData[d] = r, r.checked && this.options.cascade && (this.checkNodeDownward(r, !0), this.checkNodeUpward(r)), r.selected && n && (this.clearSelected(!1, !1), this.currentSelectedKey = r[this.options.keyField], this.emit("selected-change", r, this.currentSelectedKey)), (this.options.defaultExpandAll || r.expand) && !this.options.load && !r.isLeaf && (r.expand = !1, this.setExpand(r[this.options.keyField], !0, !1, !1, !1)), r.children.length && this.flattenData(r.children, n, l);
    }
    return l;
  }
  //#region Check nodes
  /**
   * 向下勾选/取消勾选节点，包括自身
   * @param node 需要向下勾选的节点
   * @param value 勾选或取消勾选
   * @param filtering 是否正在过滤，如果是，则考虑 `filteredNodeCheckable` Prop
   */
  checkNodeDownward(t, n, l = !1) {
    if (t.children.forEach((a) => {
      this.checkNodeDownward(a, n, l);
    }), t.isLeaf || this.options.load && !t.children.length) {
      if (!t.disabled) {
        if (l && !this.options.filteredNodeCheckable && !t._filterVisible)
          return;
        t.checked = n, t.indeterminate = !1;
      }
    } else
      this.checkParentNode(t);
  }
  /**
   * 向上勾选/取消勾选父节点，不包括自身
   * @param node 需要勾选的节点
   */
  checkNodeUpward(t) {
    let n = t._parent;
    for (; n; )
      this.checkParentNode(n), n = n._parent;
  }
  /**
   * 根据子节点的勾选状态更新当前父节点的勾选状态
   * @param node 需要勾选的节点
   */
  checkParentNode(t) {
    const n = t.children.length;
    if (!n)
      return;
    let l = !1, a = !1, i = !1;
    for (let r = 0; r < n; r++) {
      const d = t.children[r];
      if (d.checked ? l = !0 : a = !0, l && a || d.indeterminate) {
        i = !0, t.checked = !1, t.indeterminate = !0;
        break;
      }
    }
    i || (t.checked = l, t.indeterminate = !1);
  }
  //#endregion Check nodes
  //#region Utils
  /**
   * 搜索节点在指定数组中的位置
   */
  findIndex(t, n = this.flatData) {
    if (n !== null) {
      let l = t instanceof ae ? t[this.options.keyField] : t;
      const a = n.length;
      for (let i = 0; i < a; i++)
        if (n[0] instanceof ae) {
          if (l === n[i][this.options.keyField])
            return i;
        } else if (l === n[i])
          return i;
    }
    return -1;
  }
  //#endregion Utils
  //#region Mini EventTarget
  on(t, n) {
    this.listenersMap[t] || (this.listenersMap[t] = []);
    let l = [];
    Array.isArray(n) ? l = n : l = [n], l.forEach((a) => {
      this.listenersMap[t].indexOf(a) === -1 && this.listenersMap[t].push(a);
    });
  }
  off(t, n) {
    if (this.listenersMap[t])
      if (!n)
        this.listenersMap[t] = [];
      else {
        const l = this.listenersMap[t].indexOf(n);
        l > -1 && this.listenersMap[t].splice(l, 1);
      }
  }
  emit(t, ...n) {
    if (!this.listenersMap[t])
      return;
    const l = this.listenersMap[t].length;
    for (let a = 0; a < l; a++)
      this.listenersMap[t][a](...n);
  }
  disposeListeners() {
    for (const t in this.listenersMap)
      this.listenersMap[t] = [];
  }
  //#endregion Mini EventTarget
}
const Pt = de({
  name: "CLoadingIcon"
}), ye = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [l, a] of t)
    n[l] = a;
  return n;
}, jt = { viewBox: "0 0 50 50" }, Xt = /* @__PURE__ */ b("circle", {
  class: "ctree-loading-icon__circle",
  cx: "25",
  cy: "25",
  r: "20",
  fill: "none",
  "stroke-width": "5",
  "stroke-miterlimit": "10"
}, null, -1), Yt = [
  Xt
];
function zt(e, t, n, l, a, i) {
  return V(), H("svg", jt, Yt);
}
const At = /* @__PURE__ */ ye(Pt, [["render", zt]]), I = "ctree-tree-node", qt = de({
  name: "CTreeNode",
  components: {
    LoadingIcon: At
  },
  props: {
    /** 节点数据，注意！！为了性能，不让 Vue 监听过多属性，这个 data 不是完整的 TreeNode ，不包括 _parent 和 children 属性 */
    data: Object,
    /** 节点标题字段 */
    titleField: {
      type: String,
      default: ""
    },
    /** 节点唯一标识字段 */
    keyField: String,
    /** 节点渲染 render 函数 */
    render: Function,
    renderIcon: Function,
    /** 是否可多选 */
    checkable: Boolean,
    /** 是否可单选 */
    selectable: Boolean,
    /** 点击已选中节点是否取消选中 */
    unselectOnClick: Boolean,
    /** 是否禁用所有节点 */
    disableAll: Boolean,
    /** 是否可拖拽 */
    draggable: Boolean,
    /** 是否可放置 */
    droppable: Boolean,
    getNode: Function,
    getTreeNode: Function
  },
  emits: [...Xe],
  setup(e, { emit: t }) {
    var K, A;
    const n = e.data, l = v(!1), a = v(!1), i = v(!1), r = e.keyField, d = e.getNode, h = k(() => {
      var u, f, N, X, ce, ue;
      return [
        `${I}__wrapper`,
        {
          [`${I}__wrapper_is-leaf`]: (u = e.data) == null ? void 0 : u.isLeaf,
          [`${I}_disabled`]: (f = e.data) == null ? void 0 : f.selected
        },
        // 复选
        {
          [`${I}_checked`]: e.checkable && ((N = e.data) == null ? void 0 : N.checked),
          [`${I}_indeterminate`]: e.checkable && ((X = e.data) == null ? void 0 : X.indeterminate)
        },
        // 单选
        {
          [`${I}_selected`]: (ce = e.data) == null ? void 0 : ce.selected,
          [`${I}_hover`]: !((ue = e.data) != null && ue.selected) && !w()
        },
        {
          [`${I}__drop_active`]: l.value
        },
        {
          [`${I}_sub_selected`]: w()
        }
      ];
    }), p = k(() => [
      `${I}__node-body`,
      {
        [`${I}__show-element`]: n == null ? void 0 : n.reacData.showElement
      }
    ]), _ = k(() => [
      `${I}__drop`,
      {
        [`${I}__drop_active`]: a.value
      }
    ]), S = k(() => [
      `${I}__drop`,
      {
        [`${I}__drop_active`]: i.value
      }
    ]), M = k(() => {
      var u;
      return [
        `${I}__square`,
        `${I}__expand`,
        {
          [`${I}__expand_active`]: (u = e.data) == null ? void 0 : u.expand
        }
      ];
    }), G = k(() => [`${I}__loading-icon`]), Q = k(() => {
      var u, f;
      return [
        `${I}__title`,
        {
          [`${I}__title_disabled`]: e.disableAll || ((u = e.data) == null ? void 0 : u.disabled)
        },
        {
          [`${I}__title_selected`]: (f = e.data) == null ? void 0 : f.selected
        }
      ];
    }), D = k(() => d(e.data ? e.data[r] : "") || e.data || {}), U = ((K = e.data) == null ? void 0 : K.render) || e.render || null, L = k(() => de({
      name: "Render",
      functional: !0,
      render() {
        return typeof U != "function" ? St("div") : U({
          data: D.value,
          emit: t,
          nodeData: n
        });
      }
    })), B = ((A = e.data) == null ? void 0 : A.renderIcon) || e.renderIcon || null, x = k(() => de({
      name: "Render_Icon",
      functional: !0,
      render() {
        return typeof B != "function" ? St("div") : B(e.data);
      }
    })), se = k(() => {
      var f;
      let u = {};
      return e.draggable && !e.disableAll && !((f = e.data) != null && f.disabled) && (u = {
        dragstart: C
      }), u;
    }), ie = k(() => {
      let u = {};
      return e.droppable && (u = {
        dragenter: T.bind(ve()),
        dragover: c.bind(ve()),
        dragleave: O.bind(ve()),
        drop: Y.bind(ve())
      }), u;
    });
    function P() {
      var u;
      (u = e.data) != null && u.isLeaf || t("expand", D.value);
    }
    function Z() {
      var u;
      e.disableAll || (u = e.data) != null && u.disabled || !e.checkable || t("check", D.value);
    }
    function te(u) {
      var f, N;
      if (t("click", D.value, u), e.selectable) {
        if (e.disableAll || (f = e.data) != null && f.disabled || (N = e.data) != null && N.selected && !e.unselectOnClick)
          return;
        t("select", D.value);
      } else
        e.checkable ? Z() : P();
    }
    function ee(u) {
      t("node-dblclick", D.value, u);
    }
    function re(u) {
      t("node-right-click", D.value, u);
    }
    const ne = v();
    function j(u) {
      const f = ne.value.getBoundingClientRect(), N = f.height, X = u.clientY - f.top;
      return X <= N * 0.3 ? q.before : X <= N * (0.3 + 0.4) ? q.body : q.after;
    }
    function g(u, f = !1) {
      a.value = !1, l.value = !1, i.value = !1, f || (u === q.before ? a.value = !0 : u === q.body ? l.value = !0 : u === q.after && (i.value = !0));
    }
    function C(u) {
      var f;
      u.dataTransfer && u.dataTransfer.setData("node", JSON.stringify(e.data)), (f = e.data) != null && f.expand && P(), t("node-dragstart", D.value, u);
    }
    function T(u) {
      u.preventDefault();
      const f = j(u);
      g(f), t("node-dragenter", D.value, u, f);
    }
    function c(u) {
      u.preventDefault();
      const f = j(u);
      g(f), t("node-dragover", D.value, u, f);
    }
    function O(u) {
      const f = j(u);
      g(f, !0), t("node-dragleave", D.value, u, f);
    }
    function Y(u) {
      const f = j(u);
      g(f, !0), t("node-drop", D.value, u, f);
    }
    function w() {
      var u;
      return (u = e.data) == null ? void 0 : u.subSelected;
    }
    return {
      /** 节点拖拽 dragover */
      dragoverBody: l,
      /** 节点前拖拽 dragover */
      dragoverBefore: a,
      /** 节点后拖拽 dragover */
      dragoverAfter: i,
      wrapperCls: h,
      nodeBodyCls: p,
      dropBeforeCls: _,
      dropAfterCls: S,
      // squareCls,
      expandCls: M,
      loadingIconCls: G,
      titleCls: Q,
      fullData: D,
      renderFunction: U,
      renderComponent: L,
      renderIconFunction: B,
      renderIconComponent: x,
      dragListeners: se,
      dropListeners: ie,
      // titleField,
      handleExpand: P,
      handleCheck: Z,
      handleSelect: te,
      handleDblclick: ee,
      handleRightClick: re,
      nodeBody: ne
    };
  }
}), Jt = { key: 1 }, Gt = ["draggable"];
function Qt(e, t, n, l, a, i) {
  var d, h, p, _;
  const r = fe("LoadingIcon");
  return V(), H("div", {
    class: m(e.wrapperCls)
  }, [
    b("div", {
      class: m(e.dropBeforeCls)
    }, null, 2),
    b("div", pe({
      ref: "nodeBody",
      class: e.nodeBodyCls
    }, We(e.dropListeners, !0)), [
      b("div", {
        class: m(e.expandCls)
      }, [
        e.renderIconFunction ? (V(), H("div", {
          key: 0,
          onClick: t[0] || (t[0] = (...S) => e.handleExpand && e.handleExpand(...S))
        }, [
          e.renderIconFunction ? (V(), Ne(Nt(e.renderIconComponent), { key: 0 })) : oe("", !0)
        ])) : (V(), H("div", Jt, [
          b("div", {
            class: m(e.expandCls)
          }, [
            ge(b("i", {
              onClick: t[1] || (t[1] = (...S) => e.handleExpand && e.handleExpand(...S))
            }, null, 512), [
              [$e, !((d = e.data) != null && d.isLeaf) && !((h = e.data) != null && h._loading)]
            ]),
            (p = e.data) != null && p._loading ? (V(), Ne(r, {
              key: 0,
              class: m(e.loadingIconCls)
            }, null, 8, ["class"])) : oe("", !0)
          ], 2)
        ]))
      ], 2),
      b("div", pe({
        class: e.titleCls,
        onClick: t[2] || (t[2] = (...S) => e.handleSelect && e.handleSelect(...S)),
        onDblclick: t[3] || (t[3] = (...S) => e.handleDblclick && e.handleDblclick(...S)),
        onContextmenu: t[4] || (t[4] = (...S) => e.handleRightClick && e.handleRightClick(...S))
      }, We(e.dragListeners, !0), {
        draggable: e.draggable && !e.disableAll && !((_ = e.data) != null && _.disabled)
      }), [
        e.renderFunction ? (V(), Ne(Nt(e.renderComponent), { key: 0 })) : (V(), H(qe, { key: 1 }, [
          Je(ke(e.data ? e.data[e.titleField] : ""), 1)
        ], 64))
      ], 16, Gt)
    ], 16),
    b("div", {
      class: m(e.dropAfterCls)
    }, null, 2)
  ], 2);
}
const Zt = /* @__PURE__ */ ye(qt, [["render", Qt]]), wt = [
  "expand",
  "select",
  "unselect",
  "selected-change",
  "check",
  "uncheck",
  "checked-change",
  "set-data"
], en = ["node-drop", "check", "select", "expand"], tn = de({
  name: "CTree",
  components: {
    CTreeNode: Zt,
    LoadingIcon: At
  },
  emits: [
    "update:modelValue",
    ...Xe,
    ...wt
  ],
  props: {
    /** 单选模式下为字符串或数字，多选模式下为数组或者以 separator 分隔的字符串。当即可单选又可多选时，value 是多选的值 */
    modelValue: [String, Number, Array],
    // modelValue: [
    //   String,
    //   Number,
    //   Array as PropType<TreeNodeKeyType[]>,
    // ],
    /** 传入的树数据。数据量大时，不建议通过 props 传入数据，建议用 `setData` 方法代替 */
    data: {
      type: Array,
      default: () => []
    },
    /** 供未加载且选中节点查询 title 字段值用的列表，格式与 `data` 一致即可 */
    unloadDataList: {
      type: Array,
      default: () => []
    },
    /** 过滤已选时是否在列表后面展示未加载的已选节点 */
    showUnloadCheckedNodes: {
      type: Boolean,
      default: !0
    },
    /** 数据为空时显示的文本 */
    emptyText: {
      type: String,
      default: "暂无数据"
    },
    /** 节点标题字段 */
    titleField: {
      type: String,
      default: "title"
    },
    /** 节点唯一标识字段 */
    keyField: {
      type: String,
      default: "id"
    },
    /** 多选模式下 value 分隔符 */
    separator: {
      type: String,
      default: ","
    },
    /** 是否可多选 */
    checkable: {
      type: Boolean,
      default: !1
    },
    /** 是否可单选 */
    selectable: {
      type: Boolean,
      default: !1
    },
    /** 是否可勾选被过滤节点 */
    filteredNodeCheckable: {
      type: Boolean,
      default: !1
    },
    /** 父子节点是否关联 */
    cascade: {
      type: Boolean,
      default: !0
    },
    /** 是否只启用子节点，当 `多选且父子不关联` 或 `单选` 时有效 */
    enableLeafOnly: {
      type: Boolean,
      default: !1
    },
    /** 是否禁用所有节点 */
    disableAll: {
      type: Boolean,
      default: !1
    },
    /** 是否默认展开所有节点 */
    defaultExpandAll: {
      type: Boolean,
      default: !1
    },
    /**
     * 默认展开的节点 key
     * @deprecated 下一个大版本将废弃，使用 expandedKeys 代替
     */
    defaultExpandedKeys: {
      type: Array,
      default: () => []
    },
    /** 展开的节点，该 Prop 变化时，树组件将会响应，建议配合事件使用 */
    expandedKeys: {
      type: Array,
      default: () => []
    },
    /** 是否可拖拽 */
    draggable: {
      type: Boolean,
      default: !1
    },
    /** 是否可放置 */
    droppable: {
      type: Boolean,
      default: !1
    },
    /** 在放置节点之前执行的方法，返回 true 允许放置， false 可阻止放置 */
    beforeDropMethod: {
      type: Function,
      default: () => () => !0
    },
    /** 忽略模式 */
    ignoreMode: {
      type: String,
      default: Ae.none
    },
    /** 异步加载初始化时是否自动加载根节点 */
    autoLoad: {
      type: Boolean,
      default: !0
    },
    /** 异步加载方法 */
    load: Function,
    /** 节点渲染 render 函数 */
    render: Function,
    renderIcon: Function,
    /** 节点过滤方法 */
    filterMethod: Function,
    /**
     * 过滤时是否展开所有可见节点
     * 有时候可能因为开发者样式设置问题导致虚拟列表失效，而展开数据量又过多从而卡顿
     * 加上这个选项并不是为了解决上述问题，而仅仅作为一个可选项
     */
    expandOnFilter: {
      type: Boolean,
      default: !0
    },
    /** 点击已选中节点是否取消选中 */
    unselectOnClick: {
      type: Boolean,
      default: !0
    },
    /** 是否显示 loading 图标 */
    loading: {
      type: Boolean,
      default: !1
    },
    //#region Render nodes related props
    /** 根据节点最小高度计算数据总高度 */
    nodeMinHeight: {
      type: Number,
      default: 30
    },
    /** 子节点缩进 */
    nodeIndent: {
      type: Number,
      default: 20
    },
    /** 渲染节点数量，可见节点数大于此值且高度超过(容器可视高度能容纳节点数 + bufferNodeAmount)则不会渲染所有可见节点 */
    renderNodeAmount: {
      type: Number,
      default: 100
    },
    /** 当滚动到视野外的节点个数大于此值时刷新渲染节点 */
    bufferNodeAmount: {
      type: Number,
      default: 20
    },
    //#endregion Render nodes related props
    /** 节点根元素的 class ，传入函数以对每个节点定制 class */
    nodeClassName: {
      type: [
        String,
        Object,
        Array,
        Function
      ]
    }
    /**
     * 使用 padding 代替 margin 来展示子节点缩进
     * 此 Prop 是为了方便样式定制，在下个大版本将全部使用 padding
     * @deprecated
     */
    // usePadding: {
    //   type: Boolean,
    //   default: false
    // }
  },
  setup(e, t) {
    console.log(this, e, t, "this,props");
    const n = "ctree-tree", l = (s, o) => {
      if (Array.isArray(s) && Array.isArray(o)) {
        if (s.length === o.length && s.every(
          (y) => o.some((R) => R === y)
        ))
          return !0;
      } else if (s === o)
        return !0;
      return !1;
    };
    let a = Ye([]), i = v([]);
    const r = v(0), d = v(0), h = v(0), p = v(0), _ = v(0), S = v(0), M = v(0), G = v(0), Q = v(!1), D = v(
      Array.isArray(e.modelValue) ? e.modelValue.concat() : e.modelValue
    ), U = v(void 0), L = v(), B = v(), x = k(() => ({
      height: `${h.value}px`
    })), se = k(() => ({
      height: `${p.value}px`
    })), ie = k(() => [`${n}__wrapper`]), P = k(() => [`${n}__scroll-area`]), Z = k(() => [`${n}__block-area`]), te = k(() => [`${n}__empty`]), ee = k(() => [`${n}__empty-text_default`]), re = k(() => [`${n}__loading`]), ne = k(() => [`${n}__loading-wrapper`]), j = k(() => [`${n}__loading-icon`]), g = k(() => [`${n}__iframe`]), C = Xe.reduce((s, o) => (en.indexOf(o) < 0 && (s[o] = (...y) => {
      t.emit.apply(t, [o, ...y]);
    }), s), {}), T = () => ({
      store: new Wt({
        keyField: e.keyField,
        ignoreMode: e.ignoreMode,
        filteredNodeCheckable: e.filteredNodeCheckable,
        cascade: e.cascade,
        defaultExpandAll: e.defaultExpandAll,
        load: e.load,
        expandOnFilter: e.expandOnFilter
      }),
      blockNodes: []
    });
    let c = T();
    Se(
      () => e.modelValue,
      (s) => {
        if (e.checkable) {
          if (l(s, D.value))
            return;
          let o = [];
          Array.isArray(s) ? o = s.concat() : typeof s == "string" && (o = s === "" ? [] : s.split(e.separator)), c.store.clearChecked(!1, !1), c.store.setCheckedKeys(o, !0);
        } else if (e.selectable) {
          if (s === D.value)
            return;
          const o = c.store.getSelectedKey();
          s !== "" && s != null ? c.store.setSelected(s, !0) : (s === "" || s == null) && o && c.store.setSelected(o, !1);
        }
      }
    ), Se(
      () => e.data,
      (s) => {
        O(s);
      }
    ), Se(
      () => e.expandedKeys,
      () => {
        Ce();
      }
    );
    function O(s) {
      Le();
      let o = null, y = null;
      e.checkable ? Array.isArray(e.modelValue) ? o = e.modelValue.concat() : typeof e.modelValue == "string" && (o = e.modelValue === "" ? [] : e.modelValue.split(e.separator)) : e.selectable && !Array.isArray(e.modelValue) && (y = e.modelValue), c.store.setData(
        s,
        y,
        o
      ), Ce();
    }
    function Y(s, o) {
      c.store.setChecked(s, o);
    }
    function w(s, o) {
      c.store.setCheckedKeys(s, o);
    }
    function K() {
      c.store.checkAll();
    }
    function A() {
      c.store.clearChecked();
    }
    function u(s, o) {
      c.store.setSelected(s, o);
    }
    function f() {
      c.store.clearSelected();
    }
    function N(s, o, y = !0) {
      c.store.setExpand(s, o, y);
    }
    function X(s, o) {
      c.store.setExpandKeys(s, o);
    }
    function ce(s) {
      c.store.setExpandAll(s);
    }
    function ue(s) {
      return s = s || e.ignoreMode, c.store.getCheckedNodes(s);
    }
    function Qe(s) {
      return s = s || e.ignoreMode, c.store.getCheckedKeys(s);
    }
    function Ze() {
      return c.store.getIndeterminateNodes();
    }
    function et() {
      return c.store.getSelectedNode();
    }
    function tt() {
      return c.store.getSelectedKey();
    }
    function nt() {
      return c.store.getExpandNodes();
    }
    function lt() {
      return c.store.getExpandKeys();
    }
    function at() {
      return c.store.flatData.filter((s) => s._filterVisible);
    }
    function Fe(s) {
      return c.store.getNode(s);
    }
    function st() {
      return c.store.data;
    }
    function it() {
      return c.store.flatData;
    }
    function rt() {
      return c.store.flatData.length;
    }
    function dt(s, o) {
      return c.store.insertBefore(s, o);
    }
    function ot(s, o) {
      return c.store.insertAfter(s, o);
    }
    function ct(s, o) {
      return c.store.append(s, o);
    }
    function ut(s, o) {
      return c.store.prepend(s, o);
    }
    function ht(s) {
      return c.store.remove(s);
    }
    function ft(s, o) {
      const y = (R, F) => {
        const E = F[e.titleField];
        return E == null || !E.toString ? !1 : E.toString().toLowerCase().indexOf(R.toLowerCase()) > -1;
      };
      o = o || e.filterMethod || y, c.store.filter(s, o);
    }
    function pt(s) {
      if (!e.checkable)
        return;
      s = s ?? e.showUnloadCheckedNodes;
      const o = c.store.getCheckedNodes();
      if (c.store.filter("", (R, F) => F.checked), !s)
        return;
      const y = c.store.getUnloadCheckedKeys();
      if (y.length) {
        const R = y.map((F) => {
          const E = e.unloadDataList.concat(o);
          let Ue = F;
          return E.some((xe) => xe[e.keyField] === F && xe[e.titleField] != null ? (Ue = xe[e.titleField], !0) : !1), new ae(
            {
              [e.keyField]: F,
              [e.titleField]: Ue,
              checked: !0,
              isLeaf: !0
            },
            null,
            e.keyField,
            !!e.load
          );
        });
        a = R, c.blockNodes.push(...R), he(), le();
      }
    }
    function Ie() {
      return Q.value = !0, new Promise((s, o) => {
        e.load && e.load(null, s, o);
      }).then((s) => {
        Array.isArray(s) && O(s);
      }).catch(() => {
      }).then(() => {
        Q.value = !1;
      });
    }
    function gt(s, o = _e.top) {
      const y = c.store.mapData[s];
      if (!y || !y.visible)
        return;
      let R = -1;
      for (let E = 0; E < r.value; E++)
        if (c.blockNodes[E][e.keyField] === s) {
          R = E;
          break;
        }
      if (R === -1)
        return;
      let F = R * e.nodeMinHeight;
      if (o === _e.center) {
        const E = L.value.clientHeight;
        F = F - (E - e.nodeMinHeight) / 2;
      } else if (o === _e.bottom) {
        const E = L.value.clientHeight;
        F = F - (E - e.nodeMinHeight);
      } else
        typeof o == "number" && (F = F - o);
      L.value && (L.value.scrollTop = F);
    }
    function Ce() {
      e.expandedKeys.length && (c.store.setExpandAll(!1, !1), c.store.setExpandKeys(e.expandedKeys, !0));
    }
    function Ee() {
      if (a.length) {
        const s = c.store.getUnloadCheckedKeys();
        a.forEach((o) => {
          o.checked = s.indexOf(o[e.keyField]) > -1;
        });
      }
    }
    function kt(s) {
      !e.cascade && e.enableLeafOnly && !s.isLeaf || c.store.setChecked(
        s[e.keyField],
        s.indeterminate ? !0 : !s.checked,
        !0,
        !0,
        !0
      );
    }
    function Te(s) {
      e.enableLeafOnly && !s.isLeaf || (bt(s), c.store.setSelected(s[e.keyField], !s.selected));
    }
    function yt(s) {
      c.store.setExpand(s[e.keyField], !s.expand);
    }
    function Ct(s, o, y) {
      if (e.droppable && o.dataTransfer)
        try {
          const F = JSON.parse(o.dataTransfer.getData("node"))[e.keyField], E = s[e.keyField];
          if (e.beforeDropMethod(
            F,
            E,
            y
          )) {
            if (F === E)
              return;
            y === q.before ? c.store.insertBefore(F, E) : y === q.body || !s.isLeaf && s.expand ? c.store.prepend(F, E) : y === q.after && c.store.insertAfter(F, E), t.emit("node-drop", s, o, y, Fe(F)), Te(s);
          }
        } catch (R) {
          throw new Error(R);
        }
    }
    function Ve(s, o) {
      if (e.checkable) {
        let y = o;
        Array.isArray(e.modelValue) || (y = y.join(e.separator)), Array.isArray(y) ? D.value = y.concat() : D.value = y, t.emit("update:modelValue", y);
      }
    }
    function Be(s, o) {
      if (e.selectable && !e.checkable) {
        const y = o || "";
        D.value = y, t.emit("update:modelValue", y);
      }
    }
    function mt() {
      wt.forEach((s) => {
        c.store.on(s, (...o) => {
          t.emit.apply(t, [s, ...o]);
        });
      });
    }
    function Le() {
      h.value = 0, p.value = 0, L.value && (L.value.scrollTop = 0);
    }
    function Me() {
      c.blockNodes = c.store.flatData.filter(
        (s) => s.visible
      ), he(), le();
    }
    function It() {
      c.blockNodes = c.store.flatData.filter(
        (s) => s.visible
      ), he(), console.log(8908, "8908"), le();
    }
    function he() {
      r.value = c.blockNodes.length, d.value = e.nodeMinHeight * r.value;
    }
    function le() {
      Re(), me();
    }
    function Re() {
      const s = L.value.clientHeight;
      _.value = Math.max(
        e.renderNodeAmount,
        Math.ceil(s / e.nodeMinHeight) + e.bufferNodeAmount
      );
    }
    function me(s = !1) {
      if (r.value > _.value) {
        const o = L.value.scrollTop, y = Math.floor(o / e.nodeMinHeight);
        M.value = Math.floor(y / e.bufferNodeAmount) * e.bufferNodeAmount;
      } else
        M.value = 0;
      s && S.value === _.value && G.value === M.value || (i.value = c.blockNodes.slice(M.value, M.value + _.value).map((o) => Object.assign({}, o, {
        _parent: null,
        children: []
      })), h.value = M.value * e.nodeMinHeight, p.value = d.value - (h.value + i.value.length * e.nodeMinHeight), console.log(i, "renderNodes"));
    }
    function vt() {
      U.value && window.cancelAnimationFrame(U.value), S.value = _.value, G.value = M.value, U.value = window.requestAnimationFrame(
        me.bind(null, !0)
      );
    }
    let Oe = v(null);
    const bt = (s) => {
      console.log(80, "80"), Oe.value && He(Oe.value, !1), Oe.value = s, He(s, !0);
    }, He = (s, o) => {
      s.children.map((y) => {
        y.subSelected = o, y.children.length && (console.log(y, "i"), He(y, o));
      });
    }, Et = {
      setData: O,
      setChecked: Y,
      onSelectChange: bt,
      setCheckedKeys: w,
      checkAll: K,
      clearChecked: A,
      setSelected: u,
      clearSelected: f,
      setExpand: N,
      setExpandKeys: X,
      setExpandAll: ce,
      getCheckedNodes: ue,
      getCheckedKeys: Qe,
      getIndeterminateNodes: Ze,
      getSelectedNode: et,
      getSelectedKey: tt,
      getExpandNodes: nt,
      getExpandKeys: lt,
      getCurrentVisibleNodes: at,
      getTreeData: st,
      getFlatData: it,
      getNodesCount: rt,
      insertBefore: dt,
      insertAfter: ot,
      append: ct,
      prepend: ut,
      remove: ht,
      filter: ft,
      showCheckedNodes: pt,
      loadRootNodes: Ie,
      scrollTo: gt,
      updateExpandedKeys: Ce,
      updateUnloadStatus: Ee,
      handleTreeScroll: vt,
      handleNodeCheck: kt,
      handleNodeSelect: Te,
      handleNodeExpand: yt,
      handleNodeDrop: Ct,
      emitCheckableInput: Ve,
      emitSelectableInput: Be,
      // attachStoreEvents,
      resetSpaceHeights: Le,
      updateBlockNodes: Me,
      updateBlockData: he,
      updateRender: le,
      updateRenderAmount: Re,
      updateRenderNodes: me,
      getNode: Fe
    };
    return ze(() => {
      c.store.on("visible-data-change", Me), c.store.on("change", It), c.store.on("render-data-change", le), c.store.on(
        "checked-change",
        (o, y) => {
          Ve(o, y), Ee();
        }
      ), c.store.on("selected-change", Be), e.data.length ? (O(e.data), e.defaultExpandedKeys.length && c.store.setExpandKeys(e.defaultExpandedKeys, !0)) : typeof e.load == "function" && e.autoLoad && ((e.modelValue || e.unloadDataList) && O([]), Ie());
      const s = B.value;
      s != null && s.contentWindow && s.contentWindow.addEventListener("resize", le);
    }), Bt(() => {
      const s = B.value;
      s != null && s.contentWindow && s.contentWindow.removeEventListener("resize", le), c.store.disposeListeners();
      const o = T();
      c.store = o.store, c.blockNodes = o.blockNodes;
    }), mt(), {
      nonReactive: c,
      /** 未加载选中的节点，展示已选时生成，其他情况下没用 */
      unloadCheckedNodes: a,
      /** 可见节点个数 */
      blockLength: r,
      /** 可见节点总高度 */
      blockAreaHeight: d,
      /** 顶部填充高度 */
      topSpaceHeight: h,
      /** 底部填充高度 */
      bottomSpaceHeight: p,
      /** 实际渲染节点个数 */
      renderAmount: _,
      /** renderAmount 缓存 */
      renderAmountCache: S,
      /** 渲染节点（实际渲染节点） */
      renderNodes: i,
      /** 渲染开始下标 */
      renderStart: M,
      /** renderStart 缓存 */
      renderStartCache: G,
      /** 是否正在载入根节点，组件内部调用 load 时会改变此值 */
      isRootLoading: Q,
      /** 缓存的 value ，用于 value 变化时与之做比对 */
      valueCache: D,
      /** 防抖计时器 id */
      debounceTimer: U,
      topSpaceStyles: x,
      bottomSpaceStyles: se,
      wrapperCls: ie,
      scrollAreaCls: P,
      blockAreaCls: Z,
      emptyCls: te,
      emptyTextDefaultCls: ee,
      loadingCls: re,
      loadingWrapperCls: ne,
      loadingIconCls: j,
      iframeCls: g,
      treeNodeListeners: C,
      setData: O,
      setChecked: Y,
      setCheckedKeys: w,
      checkAll: K,
      clearChecked: A,
      setSelected: u,
      clearSelected: f,
      setExpand: N,
      setExpandKeys: X,
      setExpandAll: ce,
      getCheckedNodes: ue,
      getCheckedKeys: Qe,
      getIndeterminateNodes: Ze,
      getSelectedNode: et,
      getSelectedKey: tt,
      getExpandNodes: nt,
      getExpandKeys: lt,
      getCurrentVisibleNodes: at,
      getTreeData: st,
      getFlatData: it,
      getNodesCount: rt,
      insertBefore: dt,
      insertAfter: ot,
      append: ct,
      prepend: ut,
      remove: ht,
      filter: ft,
      showCheckedNodes: pt,
      loadRootNodes: Ie,
      scrollTo: gt,
      updateExpandedKeys: Ce,
      updateUnloadStatus: Ee,
      handleTreeScroll: vt,
      handleNodeCheck: kt,
      handleNodeSelect: Te,
      handleNodeExpand: yt,
      handleNodeDrop: Ct,
      emitCheckableInput: Ve,
      emitSelectableInput: Be,
      attachStoreEvents: mt,
      resetSpaceHeights: Le,
      updateBlockNodes: Me,
      updateBlockData: he,
      updateRender: le,
      updateRenderAmount: Re,
      updateRenderNodes: me,
      getNode: Fe,
      scrollArea: L,
      iframe: B,
      methods: Et
    };
  }
});
function nn(e, t, n, l, a, i) {
  const r = fe("CTreeNode"), d = fe("LoadingIcon");
  return V(), H("div", {
    class: m(e.wrapperCls)
  }, [
    b("div", {
      ref: "scrollArea",
      class: m(e.scrollAreaCls),
      onScrollPassive: t[0] || (t[0] = _t((...h) => e.handleTreeScroll && e.handleTreeScroll(...h), ["stop"]))
    }, [
      b("div", {
        class: m(e.blockAreaCls)
      }, [
        b("div", {
          style: Pe(e.topSpaceStyles)
        }, null, 4),
        (V(!0), H(qe, null, Ge(e.renderNodes, (h) => (V(), Ne(r, pe(e.$props, {
          key: h[e.keyField],
          data: h,
          getNode: e.getNode,
          getTreeNode: e.getTreeData
        }, We(e.treeNodeListeners), {
          class: typeof e.nodeClassName == "function" ? e.nodeClassName(h) : e.nodeClassName,
          style: {
            minHeight: `${e.nodeMinHeight}px`,
            paddingLeft: `${h._level * e.nodeIndent}px`
          },
          onCheck: e.handleNodeCheck,
          onSelect: e.handleNodeSelect,
          onExpand: e.handleNodeExpand,
          onNodeDrop: e.handleNodeDrop
        }), null, 16, ["data", "getNode", "getTreeNode", "class", "style", "onCheck", "onSelect", "onExpand", "onNodeDrop"]))), 128)),
        b("div", {
          style: Pe(e.bottomSpaceStyles)
        }, null, 4)
      ], 2)
    ], 34),
    ge(b("div", {
      class: m(e.emptyCls)
    }, [
      b("span", {
        class: m(e.emptyTextDefaultCls)
      }, [
        J(e.$slots, "empty", {}, () => [
          Je(ke(e.emptyText), 1)
        ])
      ], 2)
    ], 2), [
      [$e, !e.blockLength]
    ]),
    ge(b("div", {
      class: m(e.loadingCls)
    }, [
      b("div", {
        class: m(e.loadingWrapperCls)
      }, [
        J(e.$slots, "loading", {}, () => [
          Ke(d, {
            class: m(e.loadingIconCls)
          }, null, 8, ["class"])
        ])
      ], 2)
    ], 2), [
      [$e, e.loading || e.isRootLoading]
    ]),
    b("iframe", {
      ref: "iframe",
      class: m(e.iframeCls)
    }, null, 2)
  ], 2);
}
const ln = /* @__PURE__ */ ye(tn, [["render", nn]]);
function Ft(e) {
  return xt.reduce((t, n) => (t[n] = function(...l) {
    return e.value[n].apply(
      e.value,
      l
    );
  }, t), {});
}
const W = "ctree-tree-search", be = "ctree-tree-node", an = de({
  name: "CTreeSearch",
  inheritAttrs: !1,
  emits: ["checked-change", "search", "set-data", "update:modelValue"],
  components: {
    CTree: ln
  },
  props: {
    /** 兼容 Vue 2.5.16 bug */
    modelValue: [String, Number, Array],
    /** 搜索输入框的 placeholder */
    searchPlaceholder: {
      type: String,
      default: "搜索关键字"
    },
    /** 是否显示全选复选框 */
    showCheckAll: {
      type: Boolean,
      default: !0
    },
    /** 是否显示已选按钮 */
    showCheckedButton: {
      type: Boolean,
      default: !0
    },
    /** 已选按钮文字 */
    checkedButtonText: {
      type: String,
      default: "已选"
    },
    /** 是否显示底部信息 */
    showFooter: {
      type: Boolean,
      default: !0
    },
    //#region Search related
    /** 如果传入此 Prop ，触发 `search` 事件后将会执行此方法，否则会执行组件内置的搜索方法 */
    searchMethod: Function,
    /** 触发搜索的字符长度 */
    searchLength: {
      type: Number,
      default: 1
    },
    /** 禁用搜索功能 */
    searchDisabled: {
      type: Boolean,
      default: !1
    },
    /** 是否远程搜索，传入 `searchMethod` 时无效 */
    searchRemote: {
      type: Boolean,
      default: !1
    },
    /** 搜索防抖时间，单位为毫秒 */
    searchDebounceTime: {
      type: Number,
      default: 300
    }
    //#endregion Search related
  },
  setup(e, { emit: t, attrs: n, expose: l }) {
    const a = Ye({
      checked: !1,
      /** 半选 */
      indeterminate: !1,
      /** 禁用 */
      disabled: !1
    }), i = v(!1), r = v(""), d = v(void 0), h = v(0), p = v();
    let _ = Ft(p);
    const S = k({
      get: () => e.modelValue,
      set: (w) => {
        T(), t("update:modelValue", w);
      }
    }), M = k(() => [`${W}__wrapper`]), G = k(() => [`${W}__search`]), Q = k(() => [`${W}__check-all-wrapper`]), D = k(() => [
      `${W}__check-all`,
      `${be}__checkbox`,
      {
        [`${be}__checkbox_checked`]: a.checked,
        [`${be}__checkbox_indeterminate`]: a.indeterminate,
        [`${be}__checkbox_disabled`]: e.searchDisabled || a.disabled
      }
    ]), U = k(() => [`${W}__input-wrapper`]), L = k(() => [
      `${W}__input`,
      {
        [`${W}__input_disabled`]: e.searchDisabled
      }
    ]), B = k(() => [`${W}__action-wrapper`]), x = k(() => [
      `${W}__checked-button`,
      {
        [`${W}__checked-button_active`]: i.value
      }
    ]), se = k(() => [`${W}__tree-wrapper`]), ie = k(() => [`${W}__footer`]), P = k(() => "checkable" in n && n.checkable !== !1);
    function Z() {
      r.value = "";
    }
    function te() {
      return r.value;
    }
    function ee(w) {
      let K = w;
      return typeof w != "string" && (K = r.value), new Promise((A, u) => {
        clearTimeout(d.value), d.value = setTimeout(() => {
          if (!(K.length > 0 && K.length < e.searchLength))
            if (i.value = !1, t("search", K), typeof e.searchMethod == "function") {
              const f = e.searchMethod(K);
              Promise.resolve(f).then(() => {
                C(), A();
              });
            } else
              e.searchRemote ? p.value.loadRootNodes().then(() => {
                C(), A();
              }) : (p.value.filter(K), C(), A());
        }, e.searchDebounceTime);
      });
    }
    function re() {
      if (e.searchDisabled || a.disabled)
        return;
      const w = p.value.getCurrentVisibleNodes().map((K) => K[p.value.keyField]);
      a.checked || a.indeterminate ? p.value.setCheckedKeys(w, !1) : p.value.setCheckedKeys(w, !0), C();
    }
    function ne() {
      ee();
    }
    function j() {
      const w = () => {
        i.value = !i.value, i.value ? p.value.showCheckedNodes() : p.value.filter(r.value, () => !0), C();
      };
      r.value ? (Z(), ee().then(() => {
        w();
      })) : w();
    }
    function g() {
      T(), C();
    }
    function C() {
      const w = p.value.getCurrentVisibleNodes(), K = w.length;
      let A = !1, u = !1, f = !1;
      for (let N = 0; N < K; N++) {
        const X = w[N];
        if (X.checked ? A = !0 : u = !0, A && u || X.indeterminate) {
          f = !0, a.checked = !1, a.indeterminate = !0;
          break;
        }
      }
      f || (a.checked = A, a.indeterminate = !1);
    }
    function T() {
      h.value = p.value.getCheckedKeys().length;
    }
    function c(w, K) {
      C(), t("checked-change", w, K);
    }
    function O() {
      t("set-data"), g();
    }
    return ze(() => {
      P.value && !h.value && g();
    }), {
      ..._,
      treeModelValue: S,
      setChecked: (w, K) => {
        p.value.setChecked(w, K);
      },
      checkAllStatus: a,
      isShowingChecked: i,
      keyword: r,
      debounceTimer: d,
      checkedCount: h,
      wrapperCls: M,
      searchCls: G,
      checkAllWrapperCls: Q,
      checkboxCls: D,
      inputWrapperCls: U,
      inputCls: L,
      actionWrapperCls: B,
      checkedButtonCls: x,
      treeWrapperCls: se,
      footerCls: ie,
      checkable: P,
      treeRef: p,
      handleCheckAll: re,
      handleSearch: ne,
      handleShowChecked: j,
      updateCheckedCount: T,
      handleSetData: g,
      updateCheckAllStatus: C,
      getKeyword: te,
      checkedChange: c,
      onSetData: O,
      clearKeyword: Z,
      search: ee
    };
  }
}), sn = ["placeholder", "disabled"], rn = { style: { float: "right" } };
function dn(e, t, n, l, a, i) {
  const r = fe("CTree");
  return V(), H("div", {
    class: m(e.wrapperCls)
  }, [
    b("div", {
      class: m(e.searchCls)
    }, [
      e.showCheckAll && e.checkable ? (V(), H("div", {
        key: 0,
        class: m(e.checkAllWrapperCls)
      }, [
        b("div", {
          class: m(e.checkboxCls),
          onClick: t[0] || (t[0] = (...d) => e.handleCheckAll && e.handleCheckAll(...d))
        }, null, 2)
      ], 2)) : oe("", !0),
      b("div", {
        class: m(e.inputWrapperCls)
      }, [
        J(e.$slots, "search-input", {}, () => [
          ge(b("input", {
            "onUpdate:modelValue": t[1] || (t[1] = (d) => e.keyword = d),
            type: "text",
            class: m(e.inputCls),
            placeholder: e.searchPlaceholder,
            disabled: e.searchDisabled,
            onInput: t[2] || (t[2] = (...d) => e.handleSearch && e.handleSearch(...d))
          }, null, 42, sn), [
            [Ot, e.keyword]
          ])
        ])
      ], 2),
      b("div", {
        class: m(e.actionWrapperCls)
      }, [
        e.showCheckedButton && e.checkable ? (V(), H("span", {
          key: 0,
          class: m(e.checkedButtonCls),
          onClick: t[3] || (t[3] = (...d) => e.handleShowChecked && e.handleShowChecked(...d))
        }, ke(e.checkedButtonText), 3)) : oe("", !0),
        J(e.$slots, "actions")
      ], 2)
    ], 2),
    b("div", {
      class: m(e.treeWrapperCls)
    }, [
      Ke(r, pe({ ref: "treeRef" }, e.$attrs, {
        modelValue: e.treeModelValue,
        "onUpdate:modelValue": t[4] || (t[4] = (d) => e.treeModelValue = d),
        onSetData: e.onSetData,
        onCheckedChange: e.checkedChange
      }), $t({ _: 2 }, [
        Ge(e.$slots, (d, h) => ({
          name: "default",
          fn: je((p) => [
            J(e.$slots, h, we(De(p)))
          ])
        }))
      ]), 1040, ["modelValue", "onSetData", "onCheckedChange"])
    ], 2),
    e.showFooter && e.checkable ? (V(), H("div", {
      key: 0,
      class: m(e.footerCls)
    }, [
      J(e.$slots, "footer", {}, () => [
        b("span", rn, "已选 " + ke(e.checkedCount) + " 个", 1)
      ])
    ], 2)) : oe("", !0)
  ], 2);
}
const on = /* @__PURE__ */ ye(an, [["render", dn]]), z = "ctree-tree-drop", Dt = "ctree-tree-search", cn = de({
  name: "CTreeDrop",
  inheritAttrs: !1,
  emits: [
    "clear",
    "checked-change",
    "dropdown-visible-change",
    "update:modelValue"
  ],
  components: {
    CTreeSearch: on
  },
  props: {
    /** 兼容 Vue 2.5.16 bug */
    modelValue: [String, Number, Array],
    /** 下拉内容高度 */
    dropHeight: {
      type: Number,
      default: 300
    },
    /** 展示输入框 placeholder */
    dropPlaceholder: {
      type: String
    },
    /** 是否禁用 */
    dropDisabled: {
      type: Boolean,
      default: !1
    },
    /** 允许清空 */
    clearable: {
      type: Boolean,
      default: !1
    },
    /** 下拉弹出框位置 */
    placement: {
      type: String,
      default: Kt["bottom-start"]
    },
    /** 将下拉 DOM 转移到 body 中 */
    transfer: {
      type: Boolean,
      default: !1
    },
    /** 在下拉框容器上额外添加的 class */
    dropdownClassName: [String, Array],
    /** 下拉框容器最小宽度，未指定则默认为展示输入框宽度 */
    dropdownMinWidth: {
      type: Number
    },
    /** 固定下拉框容器宽度，当内容超出最小宽度不会伸长，而是出现横向滚动条 */
    dropdownWidthFixed: {
      type: Boolean,
      default: !1
    }
  },
  setup(e, { attrs: t, emit: n }) {
    const l = v(!1), a = v(0), i = v(""), r = v(), d = v(), h = v(), p = Ye({
      /** 多选选中的节点 */
      checkedNodes: [],
      /** 多选选中的节点 key */
      checkedKeys: [],
      /** 单选选中的节点 */
      selectedNode: void 0,
      /** 单选选中的节点 key */
      selectedKey: void 0
    }), _ = k({
      get: () => e.modelValue,
      set: (g) => {
        n("update:modelValue", g);
      }
    }), S = k(() => [`${z}__wrapper`]), M = k(() => [`${z}__reference`]), G = k(() => [
      `${Dt}__input`,
      `${z}__display-input`,
      {
        [`${z}__display-input_focus`]: l.value,
        [`${Dt}__input_disabled`]: e.dropDisabled
      }
    ]), Q = k(() => {
      let g = !1;
      return typeof e.dropPlaceholder == "string" && (B.value ? g = a.value === 0 : x.value && (g = i.value === "")), [
        `${z}__display-input-text`,
        {
          [`${z}__display-input-placeholder`]: g
        }
      ];
    }), D = k(() => [
      `${z}__display-icon-drop`,
      {
        [`${z}__display-icon-drop_active`]: l.value
      }
    ]), U = k(() => [`${z}__display-icon-clear`]), L = k(() => {
      const g = Array.isArray(e.dropdownClassName) ? e.dropdownClassName : [e.dropdownClassName];
      return [`${z}__dropdown`, ...g];
    }), B = k(() => "checkable" in t && t.checkable !== !1), x = k(() => "selectable" in t && t.selectable !== !1), se = k(() => B.value ? a.value === 0 && typeof e.dropPlaceholder == "string" ? e.dropPlaceholder : `已选 ${a.value} 个` : x.value ? i.value === "" && typeof e.dropPlaceholder == "string" ? e.dropPlaceholder : i.value : e.dropPlaceholder || ""), ie = k(() => B.value ? a.value !== 0 : x.value ? i.value !== "" : !1);
    function P() {
      const g = r.value.getBoundingClientRect(), C = g.width, T = g.height, c = `${typeof e.dropdownMinWidth == "number" ? e.dropdownMinWidth : C}px`;
      d.value.style.minWidth = c, d.value.style.width = e.dropdownWidthFixed ? c : "auto";
      const O = d.value.getBoundingClientRect(), Y = window.getComputedStyle(
        d.value
      ), w = parseFloat(Y.marginLeft) + parseFloat(Y.marginRight), K = parseFloat(Y.marginTop) + parseFloat(Y.marginBottom), A = O.width + w, u = O.height / 0.8 + K;
      let f = 0, N = 0;
      switch (e.transfer && (f = -999, N = -999), e.placement) {
        case "bottom-start":
          e.transfer ? (f = window.pageYOffset + g.bottom, N = window.pageXOffset + g.left) : f = T;
          break;
        case "bottom-end":
          e.transfer ? (f = window.pageYOffset + g.bottom, N = window.pageXOffset + g.right - A) : (f = T, N = C - A);
          break;
        case "bottom":
          e.transfer ? (f = window.pageYOffset + g.bottom, N = window.pageXOffset + g.left + (C - A) / 2) : (f = T, N = (C - A) / 2);
          break;
        case "top-start":
          e.transfer ? (f = window.pageYOffset + g.top - u, N = window.pageXOffset + g.left) : f = -u;
          break;
        case "top-end":
          e.transfer ? (f = window.pageYOffset + g.top - u, N = window.pageXOffset + g.right - A) : (f = -u, N = C - A);
          break;
        case "top":
          e.transfer ? (f = window.pageYOffset + g.top - u, N = window.pageXOffset + g.left + (C - A) / 2) : (f = -u, N = (C - A) / 2);
          break;
      }
      d.value.style.top = `${f}px`, d.value.style.left = `${N}px`;
    }
    function Z() {
      e.dropDisabled || (l.value = !l.value);
    }
    function te(g) {
      var C, T;
      !((C = r.value) != null && C.contains(g.target)) && !((T = d.value) != null && T.contains(g.target)) && (l.value = !1);
    }
    function ee() {
      n("clear"), B.value ? h.value.clearChecked() : x.value && h.value.clearSelected();
    }
    function re(g, C) {
      p.checkedNodes = g, p.checkedKeys = C, a.value = C.length, n("checked-change", g, C);
    }
    function ne(g, C) {
      if (p.selectedNode = g, p.selectedKey = C, g) {
        const T = h.value.$refs.treeRef.titleField;
        i.value = g[T];
      } else
        C ? i.value = C : i.value = "";
      l.value = !1;
    }
    function j() {
      const g = h.value.$refs.treeRef;
      if (p.checkedNodes = h.value.getCheckedNodes(), p.checkedKeys = h.value.getCheckedKeys(), p.selectedNode = h.value.getSelectedNode(), p.selectedKey = h.value.getSelectedKey(), B.value && (a.value = p.checkedKeys.length), x.value && e.modelValue != null) {
        const C = h.value.getNode(
          e.modelValue
        );
        if (C) {
          const T = g.titleField;
          i.value = C[T];
        } else
          i.value = e.modelValue;
      }
    }
    return ze(() => {
      document.addEventListener("click", te), e.transfer && document.body.appendChild(d.value), j();
    }), Se(
      () => l.value,
      (g) => {
        n("dropdown-visible-change", g), g ? Lt(() => {
          P();
        }) : h.value.getKeyword() && (h.value.clearKeyword(), h.value.search());
      }
    ), {
      ...Ft(h),
      treeSearchValue: _,
      dropdownVisible: l,
      checkedCount: a,
      selectedTitle: i,
      slotProps: p,
      wrapperCls: S,
      referenceCls: M,
      displayInputCls: G,
      displayInputTextCls: Q,
      dropIconCls: D,
      clearIconCls: U,
      dropdownCls: L,
      checkable: B,
      selectable: x,
      displayValue: se,
      showClearIcon: ie,
      referenceRef: r,
      dropdownRef: d,
      treeSearchRef: h,
      locateDropdown: P,
      handleRefClick: Z,
      handleDocumentClick: te,
      handleClear: ee,
      handleCheckedChange: re,
      handleSelectedChange: ne,
      handleSetData: j
    };
  }
});
function un(e, t, n, l, a, i) {
  const r = fe("CTreeSearch");
  return V(), H("div", {
    class: m(e.wrapperCls)
  }, [
    b("div", {
      ref: "referenceRef",
      class: m(e.referenceCls),
      onClick: t[1] || (t[1] = (...d) => e.handleRefClick && e.handleRefClick(...d))
    }, [
      J(e.$slots, "default", we(De(e.slotProps)), () => [
        b("div", {
          class: m(e.displayInputCls)
        }, [
          b("span", {
            class: m(e.displayInputTextCls)
          }, [
            J(e.$slots, "display", we(De(e.slotProps)), () => [
              Je(ke(e.displayValue), 1)
            ])
          ], 2),
          e.dropDisabled ? oe("", !0) : (V(), H(qe, { key: 0 }, [
            b("i", {
              class: m(e.dropIconCls)
            }, null, 2),
            e.clearable && e.showClearIcon ? J(e.$slots, "clear", { key: 0 }, () => [
              b("i", {
                class: m(e.clearIconCls),
                onClick: t[0] || (t[0] = _t((...d) => e.handleClear && e.handleClear(...d), ["stop"]))
              }, null, 2)
            ]) : oe("", !0)
          ], 64))
        ], 2)
      ])
    ], 2),
    Ke(Ht, { name: "ctree-dropdown" }, {
      default: je(() => [
        ge(b("div", {
          ref: "dropdownRef",
          class: m(e.dropdownCls),
          style: Pe({
            height: `${e.dropHeight}px`
          })
        }, [
          Ke(r, pe({
            ref: "treeSearchRef",
            modelValue: e.treeSearchValue,
            "onUpdate:modelValue": t[2] || (t[2] = (d) => e.treeSearchValue = d)
          }, e.$attrs, {
            onSetData: e.handleSetData,
            onCheckedChange: e.handleCheckedChange,
            onSelectedChange: e.handleSelectedChange
          }), $t({ _: 2 }, [
            Ge(e.$slots, (d, h) => ({
              name: h,
              fn: je((p) => [
                J(e.$slots, h, we(De(p)))
              ])
            }))
          ]), 1040, ["modelValue", "onSetData", "onCheckedChange", "onSelectedChange"])
        ], 6), [
          [$e, e.dropdownVisible]
        ])
      ]),
      _: 3
    })
  ], 2);
}
const gn = /* @__PURE__ */ ye(cn, [["render", un]]);
export {
  ae as TreeNode,
  Wt as TreeStore,
  gn as VTreeDrop,
  Zt as VTreeNode,
  on as VTreeSearch,
  ln as default
};
